<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_JOB_MATERIAL_RETURN';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/inventory/includes/ui/job_manual_cost_returns_ui.inc"); 
include_once($path_to_root . "/inventory/includes/db/job_material_issues_db.inc");
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/project_cost_functions.inc"); 
include_once($path_to_root . "/includes/db/inventory_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/lot_allocations_db.inc");  
include_once($path_to_root . "/inventory/includes/ui/lot_ui.inc");  
include_once($path_to_root . "/inventory/includes/db/lots_db.inc"); 
include_once($path_to_root . "/includes/approval_functions.inc"); 

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['ProcessedID'])) {
    page(_($help_context = $systypes_array[ST_JOB_MANUAL_COST_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['ProcessedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('jmc_return_messages');
    clear_session_variable('jmc_return_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    page(_($help_context = $systypes_array[ST_JOB_MANUAL_COST_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('jmcr_bo_messages');
    clear_session_variable('jmcr_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_JOB_MANUAL_COST_RETURN]), false, false, "", $js);
    
    global $systypes_array;
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('jmcr_rj_messages');
    clear_session_variable('jmcr_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['jmc_no']) && is_numeric($_GET['jmc_no'])) || (isset($_POST['jmc_no']) && is_numeric($_POST['jmc_no']))) {
    $_POST['jmc_no'] = isset($_GET['jmc_no']) ? $_GET['jmc_no'] : $_POST['jmc_no'];
    
    $header = get_job_material_issue_header_record($_POST['jmc_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_JOB_MANUAL_COST) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_JOB_MANUAL_COST]." record #".$_POST['jmc_no']));
            display_footer_exit();
        }
    
    $page_title = _('New '.$systypes_array[ST_JOB_MANUAL_COST_RETURN]);
    
} elseif ((isset($_GET['jmcr_no']) && is_numeric($_GET['jmcr_no'])) || (isset($_POST['jmcr_no']) && is_numeric($_POST['jmcr_no']))) {
    $_POST['jmcr_no'] = isset($_GET['jmcr_no']) ? $_GET['jmcr_no'] : $_POST['jmcr_no'];
    
    $header = get_job_material_issue_header_record($_POST['jmcr_no']);
        if (is_array($header)) {
            if ($header['type'] != ST_JOB_MANUAL_COST_RETURN) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Could not find ".$systypes_array[ST_JOB_MANUAL_COST_RETURN]." record #".$_POST['jmcr_no']));
            display_footer_exit();
        }
        
    $_POST['jmc_no'] = $header['jmr_no'];
    $page_title = _('Modify '.$systypes_array[ST_JOB_MANUAL_COST_RETURN]." #".$header['trans_no'] );
    
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Could not find ".$systypes_array[ST_JOB_MANUAL_COST_RETURN]));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_POST['Process_JMI'])) {
    $msg = save_job_manual_cost_returns($_POST['jmc_no'], $_POST['jmcr_no'], true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['REJECT_JMRT'])) {
    $msg = reject_job_manual_cost_return($_POST['jmc_no'], $_POST['jmcr_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_JMRT'])) {
    $msg = back_to_originator_job_manual_cost_return($_POST['jmc_no'], $_POST['jmcr_no']);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Create_JMI'])) {        
    $msg = save_job_manual_cost_returns($_POST['jmc_no'], $_POST['jmcr_no']);
        if ($msg['success'] !== true) {
            if (isset($msg["focus_to"])) {
                set_focus($msg["focus_to"]);            
            }
            $return_hd_row = get_job_material_issue_header_record($_POST['jmcr_no']);
                if (! is_array($return_hd_row)) {
                    $jmcr_no = $_POST['jmcr_no'] = 0; 
                }
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
        }
}

if (isset($_POST['cancel']) || isset($_POST['Refresh']) || $Mode == 'RESET') {
    clear_job_manual_cost_return_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($_POST['jmc_no']) && $_POST['jmc_no'] > 0) {
        hidden('jmc_no', $_POST['jmc_no']);
    } else {
        $_POST['jmc_no'] = 0;
    }   
        
    if (isset($_POST['jmcr_no']) && $_POST['jmcr_no'] > 0) {
        hidden('jmcr_no', $_POST['jmcr_no']);
        $button_name = 'Save';
    } else {
        $_POST['jmcr_no'] = 0;
        $button_name = 'Create';
    }

    $Ajax->activate('_page_body');
    $Ajax->activate('All_details');
    div_start('All_details');
    
        $req_hd_row = display_job_manual_cost_header_details($_POST['jmc_no'], $_POST['jmcr_no']);
        
        display_job_manual_cost_return_header($_POST['jmcr_no'], $req_hd_row);

        display_job_manual_cost_return_details($_POST['jmc_no'], $_POST['jmcr_no']);
        
        start_table();

            submit_center_first('Create_JMI', _("$button_name ".$systypes_array[ST_JOB_MANUAL_COST_RETURN]), '', 'default');    
            
            $jmcr_hd = get_job_material_issue_header_record($_POST['jmcr_no']);
            if (is_array($jmcr_hd)) {
                submit('Process_JMI', _("Process ".$systypes_array[ST_JOB_MANUAL_COST_RETURN]), true, _("Process"), false, ICON_SUBMIT);
            } 
            
            submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT); 
        
            start_table();
                if (is_array($jmcr_hd)) {
                    br(2);
                    submit_center_first('REJECT_JMRT', _("Reject ".$systypes_array[ST_JOB_MANUAL_COST_RETURN]), '', true, ICON_DELETE);  
                    
                    submit('BACK_TO_ORIGINATOR_JMRT', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                }
            
        end_table();
            
    div_end();
    
end_form(2);
end_page(@$_GET['popup'], false, false);        

?>